<form #f="ngForm" (ngSubmit)="subm(f)">
    <div ngModelGroup="contact">
        <div class="formGroup">
            <label for="firstName">First Name</label>
            <input required minlength="3" maxlength="10" pattern="banana" ngModel name="firstName" #firstname="ngModel" (change)="log(firstname)" id="firstName" type="text" class="form-control">
            <div class="alert alert-danger" *ngIf="firstname.touched && !firstname.valid">
                <div *ngIf="firstname.errors.required">First Name is Required!</div>
                <div *ngIf="firstname.errors.minlength">Should be at leaset {{firstname.errors.minlength.required}} character</div>
                <div *ngIf="firstname.errors.pattern">Doesn't match pattern</div>
            </div>
        </div>
    </div>
    <div class="formGroup">
        <label for="comment"></label>
        <textarea ngModel name="comment" class="form-control"  id="comment" cols="30" rows="10"></textarea>
    </div>
    <div class="checkbox">
        <label >
            <input type="chechbox" ngModule name="selected"> I accept terms of ....
        </label>
    </div>
    <div class="form-group">
        <label for="contactMethod"></label>
        <select multiple ngModel name="contact" id="contactMethod" class="form-control">
            <option value=""></option>
            <option *ngFor="let option of contactMethods" [value]="option.id">{{option.name}}</option>
        </select>
    </div>
    <div *ngFor="let gozineh of contactMethods" class="radio">
        <label>
           <input ngModel type="radio" name="contactMethods" [value]="gozineh.id">{{gozineh.name}}
        </label>
    </div>
    <p>
        {{f.value| json}}
    </p>
    <button class="btn btn-primary" [disabled]="!f.valid">submit</button>
</form>
